//  ChatServer.java
//
//  Last modified 1/30/2000 by Alan Frindell
//
//  RMI interface file for the Chat Server.
//
//  This is the interface to the ChatServer presented to remote Chat clients.
//
//  You will need to modify this file in accordance with your changes to 
//  ChatServerImpl.java

package Chat;

import java.rmi.*;
import java.math.BigInteger;
import java.security.*;

// Crypto
import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

interface ChatServer extends Remote {

    public Integer getClientID() throws RemoteException;
    
    public PublicKey keyExchange(PublicKey pubKey, Integer clientID)
	throws RemoteException;
    
    public BigInteger []getDHParams() throws RemoteException;

    public void register(ChatConsumer consumer, Integer ClientID) 
	throws RemoteException;
    
    public void unregister(Integer clientID) throws RemoteException;
    
    public void postMessage(ChatMessage sealedMsg, Integer clientID) 
	throws RemoteException;
}
